import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useRef as ee, useState as E, useMemo as M, useCallback as te, useEffect as re } from "react";
import { theme as le, Row as f, Col as i, Space as D, Form as h, Select as _, Spin as se, Typography as oe, Table as ne, Pagination as ce, Flex as ie, Empty as K } from "antd";
import G from "../../BitzButton/index.mjs";
import { getColumns as ae, getExpandable as ue, getLayoutConfig as pe } from "./getData.mjs";
import de from "../TextBlock/index.mjs";
import xe from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import he from "../../../node_modules/@ant-design/icons/es/icons/InfoCircleOutlined.mjs";
import me from "../../../node_modules/@ant-design/icons/es/icons/CloseOutlined.mjs";
function Be({ columns: T, tableData: B, total: H, loading: m, loadingFailed: b, loadAgain: J, page: y, onPageChange: k, searchInput: O, showToolTagSelect: I, toolTags: Q, onToolTagChange: g, lrLayout: w, parentRender: P, keys: R, rows: z, fieldNames: r, onChange: d, onDropdownVisibleChange: j }) {
  var A;
  const C = ee(null), v = xe(C), { token: a } = le.useToken(), [o, W] = E([]), [s, $] = E([]), [q, L] = E(void 0), U = (t, l) => {
    L(t), g == null || g(t, l), t || (j(!0), setTimeout(() => {
      j(!1);
    }, 0));
  }, X = M(() => ae(T, B, y), [T]), Y = {
    selectedRowKeys: o,
    onSelect: (t, l) => {
      if (l)
        o.push(t[r.value]), s.push(t), d(o, s);
      else {
        const u = s.filter((p) => p[r.value] !== t[r.value]);
        d(u.map((p) => p[r.value]), u);
      }
    },
    onSelectAll: (t, l, u) => {
      const p = u.map((c) => c[r.value]);
      if (t) {
        const c = o.concat(p), S = s.concat(u);
        d(c, S);
      } else {
        const c = o == null ? void 0 : o.filter((x) => !p.includes(x)), S = /* @__PURE__ */ new Map();
        u.forEach((x) => {
          S.set(x[r.value], x);
        });
        const N = s == null ? void 0 : s.filter((x) => !S.has(x[r.value]));
        d(c, N);
      }
    }
  }, Z = te(() => ue(r.items), [r.items]), F = (t, l) => e.jsxs("span", { style: { color: a.colorText }, children: [t[0], " ", e.jsx("span", { style: { color: a.colorPrimary, fontWeight: 600 }, children: l }), " ", t[1]] }), V = () => {
    const t = (l) => {
      const u = s.findIndex((c) => c[r.value] === l[r.value]), p = o.findIndex((c) => c === l[r.value]);
      s.splice(u, 1), o.splice(p, 1), d(o, s);
    };
    return e.jsxs(D, { direction: "vertical", style: {
      width: "calc(100% - 5px)",
      paddingRight: 5,
      maxHeight: s.length ? 220 : "auto",
      overflow: "hidden auto"
    }, children: [s.map((l) => e.jsxs(ie, { justify: "space-between", style: {
      padding: "4px 8px",
      border: `1px solid ${a.colorBorder}`,
      backgroundColor: "#f5f5f5",
      borderRadius: a.borderRadiusSM,
      overflow: "hidden"
    }, children: [e.jsx("div", { style: { width: "calc(100% - 15px)" }, children: e.jsx(de, { value: l[r.label] }) }), e.jsx(me, { style: {
      color: a.colorError,
      fontSize: 13,
      cursor: "pointer"
    }, onClick: () => t(l) })] }, l[r.value])), !s.length && e.jsx(K, { image: K.PRESENTED_IMAGE_SIMPLE })] });
  }, n = M(() => pe(w, I), [w, I]);
  return re(() => {
    W(R ?? []), $(z ?? []);
  }, [R, z]), e.jsxs(f, { gutter: n.gutter, children: [e.jsx(i, { span: n.left.span, children: w && P && P(n.spaceSize, v == null ? void 0 : v.height) }), e.jsx(i, { span: n.right.span, children: e.jsxs(D, { direction: "vertical", size: n.spaceSize, style: { width: "100%" }, children: [e.jsx(h, { className: "tableSelectPopupSearchForm", children: e.jsx(f, { gutter: [16, 16], children: e.jsx(i, { span: 24, children: e.jsxs(f, { justify: "space-between", gutter: [16, 16], children: [e.jsx(i, { span: n.right.search, children: e.jsx(h.Item, { children: O }) }), e.jsx(i, { span: n.right.operation, children: e.jsxs(f, { justify: "end", gutter: 8, children: [e.jsx(i, { span: n.right.toolTagSelect, children: e.jsx(h.Item, { children: e.jsx(_, { allowClear: !0, className: "tableSelectPopupToolTagSelect", style: {
    width: "100%",
    "--toolTagSelect-color": m ? a.colorTextDisabled : a.colorText
  }, placeholder: "常用标签", showSearch: !1, disabled: m, options: Q, value: q, onChange: U, onDropdownVisibleChange: j }) }) }), e.jsx(i, { span: n.right.totalSelect, children: e.jsx(h.Item, { children: e.jsxs("div", { className: "tableSelectPopupTotalSelect", children: [e.jsx(_, { style: { width: "100%" }, mode: "multiple", placeholder: "", showSearch: !1, options: s, value: o, fieldNames: r, popupClassName: "tableSelectPopupTotalPopup", dropdownRender: V, tagRender: () => e.jsx(e.Fragment, {}), onDropdownVisibleChange: j }), e.jsx("div", { className: "tableSelectPopupTotalSelectTip", children: F(["已选择", "条数据"], o.length || 0) })] }) }) }), e.jsx(i, { span: n.right.button, children: e.jsx(G, { type: "primary", danger: !0, onClick: () => d([], [], "clear"), children: "清空" }) }), e.jsx(i, { span: n.right.button, children: e.jsx(G, { type: "primary", onClick: () => d([], [], "confirm"), children: "确认" }) })] }) })] }) }) }) }), e.jsx("div", { ref: C, ...b && {
    className: "pointerMouse",
    onClick: () => J()
  }, children: e.jsx(se, { spinning: b, indicator: e.jsx(he, {}), tip: e.jsx(oe.Text, { type: "danger", children: "加载失败，点击重试" }), children: e.jsx(ne, { rowKey: r.value, loading: m, bordered: !0, sticky: !0, size: "small", scroll: { y: 400 }, pagination: !1, rowSelection: Y, columns: X, dataSource: B, ...b && { className: "loadingFailedTable" }, ...Z(), style: {
    "--tableBody-bootomBorderColor": (A = a.Table) == null ? void 0 : A.borderColor
  } }) }) }), e.jsx(h, { children: e.jsx(h.Item, { style: { marginBottom: 0 }, children: e.jsx(ce, { disabled: m, className: "tableSelectPopupTablePagination", size: "small", current: y.pageIndex, pageSize: y.pageSize, showTotal: (t) => F(["共", "条"], t), showSizeChanger: !0, showQuickJumper: !0, total: H, onChange: k, onShowSizeChange: (t, l) => k(1, l) }) }) })] }) })] });
}
export {
  Be as default
};
