import { j as s } from "../../../node_modules/react/jsx-runtime.mjs";
import { create as V, useModal as W, antdModalV5 as q } from "@ebay/nice-modal-react";
import { Modal as z, Checkbox as G } from "antd";
import o from "./index.module.less.mjs";
import { useState as H, useContext as J, useCallback as A, useMemo as p } from "react";
import { TableContext as Q } from "../../BitzTableProvider/index.mjs";
import { genColumnKey as w, columnSort as U } from "../../BitzTableProvider/utils/index.mjs";
import I from "../../../node_modules/classnames/index.mjs";
import { DndContext as X, DragOverlay as Y, defaultDropAnimationSideEffects as Z } from "../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as _, verticalListSortingStrategy as $, arrayMove as L } from "../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import P from "./DndItem.mjs";
import { restrictToVerticalAxis as ee, restrictToWindowEdges as se } from "../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import B from "../../../node_modules/lodash-es/omit.mjs";
import le from "../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
import te from "../../../node_modules/@ant-design/icons/es/icons/DragOutlined.mjs";
const oe = {
  sideEffects: Z({
    styles: {
      active: {
        opacity: "0.5"
      }
    }
  })
}, ye = V(() => {
  var C;
  const g = W(), [u, j] = H(null), { columnsMap: r, setColumnsMap: b, sortKeyColumns: x, setSortKeyColumns: K, clearPersistenceStorage: v, ...t } = J(Q), F = A(() => {
    v == null || v(), b(t.defaultColumnKeyMap);
  }, []), h = p(() => {
    var l, a;
    const e = [];
    return (l = t == null ? void 0 : t.columns) != null && l.length && ((a = t == null ? void 0 : t.columns) == null || a.map(({ key: m, dataIndex: n, ...i }) => {
      const f = w(m || n, [m || n].filter(Boolean).join("-")), d = r[f || "null"];
      return (d == null ? void 0 : d.show) !== !1 && e.push({
        key: f,
        ...B(i, ["className"]),
        selectable: !1,
        disabled: (d == null ? void 0 : d.disable) === !0
      }), d;
    })), e.sort(U(r));
  }, [r, t == null ? void 0 : t.columns]), y = A((e) => x == null ? void 0 : x.findIndex((l) => l === e), [x]), k = p(() => u ? y(u) : -1, [u, y]), E = p(() => {
    const e = [], l = /* @__PURE__ */ new Map();
    return { list: ((m, n) => m.map(({ key: i, dataIndex: f, children: d, ...D }) => {
      var M;
      const N = w(i || f, [n == null ? void 0 : n.columnKey, D.index].filter(Boolean).join("-")), c = r[N || "null"] || { show: !0 };
      (c == null ? void 0 : c.show) !== !1 && !d && e.push(N);
      const S = {
        key: N,
        ...B(D, ["className"]),
        selectable: !1,
        disabled: c.disable === !0,
        disableCheckbox: typeof c.disable == "boolean" ? c == null ? void 0 : c.disable : (M = c == null ? void 0 : c.disable) == null ? void 0 : M.checkbox,
        isLeaf: n ? !0 : void 0
      };
      return l.set(i, S), S;
    }))(t == null ? void 0 : t.columns), keys: e, map: l };
  }, [r, t == null ? void 0 : t.columns]), O = (e, l) => {
    const a = { ...r };
    ((n) => {
      const i = { ...a[n] };
      i.show = !e, a[n] = i;
    })(l.key), b({ ...a });
  }, T = (e, l) => {
    const a = { ...r }, m = L(x, e, l);
    m.forEach((n, i) => {
      a[n] = { ...a[n] || {}, order: i };
    }), b(a), K(m);
  }, R = p(() => {
    var e, l;
    return u ? ((l = (e = t == null ? void 0 : t.columns) == null ? void 0 : e.find((a) => a.key === u)) == null ? void 0 : l.title) ?? "" : "";
  }, [t == null ? void 0 : t.columns, u, r, x]);
  return s.jsxs(z, { title: "自定义列", ...q(g), width: 600, footer: !1, children: [s.jsx("div", { className: o.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }), s.jsxs("div", { className: o.contaiern, children: [s.jsxs("div", { className: o.block, children: [s.jsxs("div", { className: o.header, children: [s.jsx("div", { className: o.title, children: "可用列" }), s.jsx("div", {})] }), s.jsx("div", { className: o.body, children: s.jsx("ul", { className: o.content, children: (C = E.list) == null ? void 0 : C.map((e) => {
    const l = E.keys.includes(e.key);
    return s.jsxs("li", { className: I(o.item, {
      [o.checked]: !l
    }), onClick: () => !e.disabled && O(l, e), children: [s.jsx(G, { checked: l, disabled: e.disabled }), s.jsx("span", { className: o["content-item-text"], children: e.title })] }, e.key);
  }) }) })] }), s.jsxs("div", { className: o.block, children: [s.jsxs("div", { className: o.header, children: [s.jsx("div", { className: o.title, children: "选定的列" }), s.jsxs("div", { className: o.reset, onClick: F, children: [s.jsx("div", { children: "重置  " }), s.jsx(le, {})] })] }), s.jsx("div", { className: o.body, children: s.jsxs(X, { modifiers: [ee, se], onDragStart: (e) => {
    const { active: l } = e;
    l && j(l == null ? void 0 : l.id);
  }, onDragCancel: () => j(null), onDragEnd: (e) => {
    j(null);
    const { over: l } = e;
    if (l) {
      const a = y(l.id);
      k !== a && T(k, a);
    }
  }, children: [s.jsx(_, { items: h == null ? void 0 : h.map((e) => e.key), strategy: $, children: s.jsx("ul", { className: o.content, style: { background: "#fff" }, children: h == null ? void 0 : h.map((e) => s.jsx(P, { item: e }, e.key)) }) }), s.jsx(Y, { adjustScale: !1, dropAnimation: oe, children: u ? s.jsxs("li", { className: I(o.moveItem), children: [s.jsx(te, { className: o.dragIcon }), s.jsx("span", { className: o["moveItem-text"], children: R })] }) : null })] }) })] })] })] });
});
export {
  ye as default
};
